import cgi
import sys
import os
import string

class Request:
    def __init__(self):
        self.__fields = cgi.FieldStorage()
        self.__sent_headers = 0

    def has_field(self, name):
        return self.__fields.has_key(name)

    def field_value(self, name):
        field = self.__fields[name]
        if type(field) is type([]):
            value = []
            for elem in field:
                value.append(elem.value)
            return value
        return field.value

    def field_names(self):
        return self.__fields.keys()

    def get_uri(self):
        return os.environ['REQUEST_URI']

    def get_header(self, name):
        env_name = 'HTTP_' + string.upper(string.replace(name, '-', '_'))
        return os.environ.get(env_name)

    def write_header(self, name, value):
        if not self.__sent_headers:
            sys.stdout.write('%s: %s\n' % (name, value))

    def end_headers(self):
        if not self.__sent_headers:
            sys.stdout.write('\n')
            self.__sent_headers = 1

    def write_content(self, data):
        self.end_headers()
        sys.stdout.write(data)
        sys.stdout.flush()
