
# Include functionality tests.
#
# $Id: include.py,v 1.1 2002/01/08 09:51:30 andrewm Exp $

import unittest
import albatross
import albatross_test

class IncludeCase(albatross_test.AlbatrossTestCase):
    template_dir = "include"
    
    def check_name(self):
        self.html_test("name.html", "plain\n")

    def check_expr(self):
        self.ctx.locals.filename = "name.html"
        self.html_test("expr.html", "plain\n")

    def check_nested(self):
        self.html_test("nested.html", "plain\n")

    def check_nxfile(self):
	self.assertRaises(albatross.TemplateLoadError, self.html_test, "incnxfile.html", "(none)")

class IncludeSuite(unittest.TestSuite):
    test_list = (
        "check_name",
        "check_expr",
        "check_nested",
        "check_nxfile",
    )
    def __init__(self):
        unittest.TestSuite.__init__(self, map(IncludeCase, self.test_list))

def suite():
    return IncludeSuite()

if __name__ == '__main__':
    unittest.main(defaultTest='suite')
